/* Generated automatically by the program `genattr'
   from the machine description file `md'.  */

#ifndef GCC_INSN_ATTR_H
#define GCC_INSN_ATTR_H

#define HAVE_ATTR_alternative
#define get_attr_alternative(insn) which_alternative
#define HAVE_ATTR_cpu
enum attr_cpu {CPU_V7, CPU_CYPRESS, CPU_V8, CPU_SUPERSPARC, CPU_SPARCLITE, CPU_F930, CPU_F934, CPU_HYPERSPARC, CPU_SPARCLITE86X, CPU_SPARCLET, CPU_TSC701, CPU_V9, CPU_ULTRASPARC};
extern enum attr_cpu get_attr_cpu PARAMS ((void));

#define HAVE_ATTR_isa
enum attr_isa {ISA_V6, ISA_V8, ISA_V9, ISA_SPARCLET};
extern enum attr_isa get_attr_isa PARAMS ((void));

#define HAVE_ATTR_arch
enum attr_arch {ARCH_ARCH32BIT, ARCH_ARCH64BIT};
extern enum attr_arch get_attr_arch PARAMS ((void));

#define HAVE_ATTR_type
enum attr_type {TYPE_IALU, TYPE_COMPARE, TYPE_SHIFT, TYPE_LOAD, TYPE_SLOAD, TYPE_STORE, TYPE_UNCOND_BRANCH, TYPE_BRANCH, TYPE_CALL, TYPE_SIBCALL, TYPE_CALL_NO_DELAY_SLOT, TYPE_RETURN, TYPE_IMUL, TYPE_IDIV, TYPE_FPLOAD, TYPE_FPSTORE, TYPE_FP, TYPE_FPMOVE, TYPE_FPCMOVE, TYPE_FPCMP, TYPE_FPMUL, TYPE_FPDIVS, TYPE_FPDIVD, TYPE_FPSQRTS, TYPE_FPSQRTD, TYPE_CMOVE, TYPE_MULTI, TYPE_MISC};
extern enum attr_type get_attr_type PARAMS ((rtx));

#define HAVE_ATTR_empty_delay_slot
enum attr_empty_delay_slot {EMPTY_DELAY_SLOT_FALSE, EMPTY_DELAY_SLOT_TRUE};
extern enum attr_empty_delay_slot get_attr_empty_delay_slot PARAMS ((rtx));

#define HAVE_ATTR_branch_type
enum attr_branch_type {BRANCH_TYPE_NONE, BRANCH_TYPE_ICC, BRANCH_TYPE_FCC, BRANCH_TYPE_REG};
extern enum attr_branch_type get_attr_branch_type PARAMS ((rtx));

#define HAVE_ATTR_pic
enum attr_pic {PIC_FALSE, PIC_TRUE};
extern enum attr_pic get_attr_pic PARAMS ((rtx));

#define HAVE_ATTR_length
extern int get_attr_length PARAMS ((rtx));
extern void shorten_branches PARAMS ((rtx));
extern int insn_default_length PARAMS ((rtx));
extern int insn_variable_length_p PARAMS ((rtx));
extern int insn_current_length PARAMS ((rtx));

#include "insn-addr.h"

#define HAVE_ATTR_fptype
enum attr_fptype {FPTYPE_SINGLE, FPTYPE_DOUBLE};
extern enum attr_fptype get_attr_fptype PARAMS ((rtx));

#define HAVE_ATTR_in_call_delay
enum attr_in_call_delay {IN_CALL_DELAY_FALSE, IN_CALL_DELAY_TRUE};
extern enum attr_in_call_delay get_attr_in_call_delay PARAMS ((rtx));

#define HAVE_ATTR_eligible_for_sibcall_delay
enum attr_eligible_for_sibcall_delay {ELIGIBLE_FOR_SIBCALL_DELAY_FALSE, ELIGIBLE_FOR_SIBCALL_DELAY_TRUE};
extern enum attr_eligible_for_sibcall_delay get_attr_eligible_for_sibcall_delay PARAMS ((rtx));

#define HAVE_ATTR_leaf_function
enum attr_leaf_function {LEAF_FUNCTION_FALSE, LEAF_FUNCTION_TRUE};
extern enum attr_leaf_function get_attr_leaf_function PARAMS ((void));

#define HAVE_ATTR_eligible_for_return_delay
enum attr_eligible_for_return_delay {ELIGIBLE_FOR_RETURN_DELAY_FALSE, ELIGIBLE_FOR_RETURN_DELAY_TRUE};
extern enum attr_eligible_for_return_delay get_attr_eligible_for_return_delay PARAMS ((rtx));

#define HAVE_ATTR_in_return_delay
enum attr_in_return_delay {IN_RETURN_DELAY_FALSE, IN_RETURN_DELAY_TRUE};
extern enum attr_in_return_delay get_attr_in_return_delay PARAMS ((rtx));

#define HAVE_ATTR_in_branch_delay
enum attr_in_branch_delay {IN_BRANCH_DELAY_FALSE, IN_BRANCH_DELAY_TRUE};
extern enum attr_in_branch_delay get_attr_in_branch_delay PARAMS ((rtx));

#define HAVE_ATTR_in_uncond_branch_delay
enum attr_in_uncond_branch_delay {IN_UNCOND_BRANCH_DELAY_FALSE, IN_UNCOND_BRANCH_DELAY_TRUE};
extern enum attr_in_uncond_branch_delay get_attr_in_uncond_branch_delay PARAMS ((rtx));

#define HAVE_ATTR_in_annul_branch_delay
enum attr_in_annul_branch_delay {IN_ANNUL_BRANCH_DELAY_FALSE, IN_ANNUL_BRANCH_DELAY_TRUE};
extern enum attr_in_annul_branch_delay get_attr_in_annul_branch_delay PARAMS ((rtx));

#define DELAY_SLOTS
extern int num_delay_slots PARAMS ((rtx));
extern int eligible_for_delay PARAMS ((rtx, int, rtx, int));

extern int const_num_delay_slots PARAMS ((rtx));

#define ANNUL_IFFALSE_SLOTS
extern int eligible_for_annul_false PARAMS ((rtx, int, rtx, int));
#define INSN_SCHEDULING

extern int result_ready_cost PARAMS ((rtx));
extern int function_units_used PARAMS ((rtx));

extern const struct function_unit_desc
{
  const char *const name;
  const int bitmask;
  const int multiplicity;
  const int simultaneity;
  const int default_cost;
  const int max_issue_delay;
  int (*const ready_cost_function) PARAMS ((rtx));
  int (*const conflict_cost_function) PARAMS ((rtx, rtx));
  const int max_blockage;
  unsigned int (*const blockage_range_function) PARAMS ((rtx));
  int (*const blockage_function) PARAMS ((rtx, rtx));
} function_units[];

#define FUNCTION_UNITS_SIZE 17
#define MIN_MULTIPLICITY 1
#define MAX_MULTIPLICITY 4
#define MIN_SIMULTANEITY 0
#define MAX_SIMULTANEITY 1
#define MIN_READY_COST 1
#define MAX_READY_COST 63
#define MIN_ISSUE_DELAY 1
#define MAX_ISSUE_DELAY 63
#define MIN_BLOCKAGE 1
#define MAX_BLOCKAGE 63
#define BLOCKAGE_BITS 7
#define INSN_QUEUE_SIZE 64

#define ATTR_FLAG_forward	0x1
#define ATTR_FLAG_backward	0x2
#define ATTR_FLAG_likely	0x4
#define ATTR_FLAG_very_likely	0x8
#define ATTR_FLAG_unlikely	0x10
#define ATTR_FLAG_very_unlikely	0x20

#endif /* GCC_INSN_ATTR_H */
